/*
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <time.h>
#include <errno.h>
#include "limits.h"
#include <console.h>
*/
#include "liblisotd_read_LISOTD.h"

main(int argc, char *argv[])
{
	struct anOTDDataset OldData;
	struct lis_orbit TheData, TheData2;
	struct anOTDBoundset Bounds;

    Initialize();
    ResetAllBounds(&Bounds);
  
  	TheData = GetData("TRMM_LIS_SC.03.4_1998.026.00933", &Bounds);
  	WriteData(TheData, MINI_HDF, "test.lis.hdf",O,A,F,G,E);
  	WriteData(TheData, ASCII_SINGLE, "test.lis",!O,!A,F,!G,!E);
  	
  	TheData2 = GetData("test.mlab.hdf",&Bounds);
  	WriteData(TheData2, MINI_HDF, "test.otd.hdf",O,A,F,G,E);
  	WriteData(TheData2, ASCII_SINGLE, "test.otd",!O,!A,F,!G,!E);
  	
  	
  	/*
    TheData = GetLISData("TRMM_LIS_SC.03.4_1998.026.00933", &Bounds);
		WriteLISData(TheData, MINI_HDF,"test.lis.hdf",O,A,F,G,E);
	
	TheData = GetLISData("test.lis.hdf",&Bounds);
	WriteLISData(TheData, ASCII_SINGLE,"test.lis",!O,A,F,G,E);
	WriteLISData(TheData, ASCII_TREE,"test.lis",O,A,F,G,E);
	*/
	/*
	OldData = GetData("test.mlab.hdf",&Bounds);
	TheData = OTD_to_LIS(&OldData);
	*/
	/*
	WriteData(TheData, ASCII_SINGLE, "test.mlab.hdf", !O, A, F, !G, !E);
	
	WriteData(TheData, MINI_HDF,"test.mlab.hdf",O,A,F,G,E);
    
    */   	
	
	FreeData(&TheData);

    return(0);

}
