/* Work in progress ... ignore this file! */

#include "liblisotd_read_LISOTD.h"
#include <stdio.h>

struct theMetadataHandling  HandleMetadata;

char TLEPath[132];
char TLEName[10];

#define NTLE 39
	
void SetTLEFilePath(path)
char path[132];
{
    extern char TLEPath[132];
    sprintf(TLEPath, "%s", path);    
}

void pickTleFile(TAI)
double TAI;
{
   extern char TLEName[10];
   char Name[10];
   extern int numTLEFIles;
   int tle=0;
   struct aUTCDateTime UTCtest;
   double TAItest;
   struct aTLEInfoSet TLEInfo[NTLE] = 
       {{95,  4,  2}, {95,  4,  9}, {95,  4, 15}, {95,  4, 23}, 
	{95,  4, 30}, {95,  5,  7}, {95,  5, 21}, {95,  6,  3}, 
	{95,  6, 11}, {95,  6, 18}, {95,  6, 25}, {95,  6, 30}, 
	{95,  7,  9}, {95,  7, 16}, {95,  7, 22}, {95,  8,  6}, 
	{95,  8, 13}, {95,  8, 20}, {95,  8, 27}, {95,  9,  3}, 
	{95,  9, 10}, {95,  9, 17}, {95,  9, 24}, {95, 10,  1}, 
	{95, 10, 10}, {95, 10, 15}, {95, 10, 22}, {95, 10, 29}, 
	{95, 11,  5}, {95, 11, 12}, {95, 11, 19}, {95, 11, 26}, 
	{95, 12,  3}, {95, 12, 10}, {95, 12, 17}, {95, 12, 24}, 
	{95, 12, 31}, {96,  1,  7}, {96,  1, 14}};
    
   do {
       UTCtest.year = TLEInfo[tle].year+1900;
       UTCtest.month = TLEInfo[tle].month;
       UTCtest.day = TLEInfo[tle].day;
       UTCtest.hour = UTCtest.minute = 0; 
       UTCtest.second = 0.0;
       TAItest = UTC_to_TAI93(UTCtest);
       tle++;
   } while ((TAI > TAItest) && (tle < NTLE));
   
   tle--;
   UTCtest.year = TLEInfo[tle].year+1900;
   UTCtest.month = TLEInfo[tle].month;
   UTCtest.day = TLEInfo[tle].day;
   UTCtest.hour = UTCtest.minute = 0; 
   UTCtest.second = 0.0;
   TAItest = UTC_to_TAI93(UTCtest);
   if ((TAItest > TAI) && (tle > 0)) tle--;

   sprintf(Name, "el%02ld%02ld%02ld", TLEInfo[tle].year, TLEInfo[tle].month, 
				   TLEInfo[tle].day);
   strcpy(TLEName,Name);
   printf("%12.3f %d %s\n",TAI,tle,TLEName);
   return;
}


struct anOTDDataset   		GetPointCoincidence(OTD_Data, Point_Data, Bounds, Parameters)
	struct anOTDDataset			*OTD_Data;
	struct aPointDataset		*Point_Data;
	struct anOTDBoundset 		*Bounds;
	struct aCoincParamset		Parameters;
{
    double		    		delr, delt, az;
    double	            	dwelltime, starttime, endtime;
    float		    		fraction_done,  found_fraction,  next_fraction;
    int			    		*Use;
    int			    		TimeOK, PositionOK, inbounds;
    long		   			num_orbits, orbit, viewtime, vt2, idx, gridlon, datum;
    long		    		num_data_checked, area, flash;
    struct		    		anOTDBoundset   SmallBounds;
    struct anOTDDataset	    FoundData;
    struct anXYTtriplet	    Point_xyt, OTD_xyt;
    double peak_rad;

    Point_Data->Results.num_out_of_bounds   = 0;
    Point_Data->Results.num_not_seen	    = 0;
    Point_Data->Results.num_not_found	    = 0;
    Point_Data->Results.num_found	    	= 0;
    
    num_orbits 				= OTD_Data->num_orbits;
    FoundData.num_orbits 	= OTD_Data->num_orbits;
    FoundData.Orbits  		= (struct COrbit *)calloc((int)(num_orbits), sizeof(struct COrbit));
  
    /* First reduce the viewtime granules to those within the desired 
     *    spatial/temporal bounds.
     */
     
    for (orbit = 0; orbit < num_orbits; orbit++) {
    	
        printf("Point coinc: %ld view time granules in orbit %d\n", 
	    		OTD_Data->Orbits[orbit].num_viewtimes, orbit);
		FoundData.Orbits[orbit].num_viewtimes = 0;
		Use = (int *)calloc((long)OTD_Data->Orbits[orbit].num_viewtimes, sizeof(int));
	
		for (viewtime = 0; viewtime < OTD_Data->Orbits[orbit].num_viewtimes; viewtime++) {
		    TimeOK = !Bounds->TimeWindow.Active;
		    if (!TimeOK) {
				TimeOK = (((OTD_Data->Orbits[orbit].ViewTimes[viewtime].TAI93_start +
				            OTD_Data->Orbits[orbit].ViewTimes[viewtime].duration) >= Bounds->TimeWindow.Start.TAI93) &&
						   (OTD_Data->Orbits[orbit].ViewTimes[viewtime].TAI93_start <= Bounds->TimeWindow.End.TAI93) &&
						   (OTD_Data->Orbits[orbit].ViewTimes[viewtime].duration >= Parameters.min_viewtime));
	    	}
		    PositionOK = !Bounds->AreaBound.Active;
		    if (TimeOK && !PositionOK) 
				PositionOK = CheckLocation(OTD_Data->Orbits[orbit].ViewTimes[viewtime].grid_point, Bounds);
		    Use[viewtime] = (TimeOK && PositionOK);
		    if (Use[viewtime]) 
		    	FoundData.Orbits[orbit].num_viewtimes++;
		}
	
		FoundData.Orbits[orbit].ViewTimes =  (struct otd_View_time *)
			calloc(FoundData.Orbits[orbit].num_viewtimes, sizeof(struct CViewTime));
	
		vt2 = 0;
		for (viewtime = 0; viewtime < OTD_Data->Orbits[orbit].num_viewtimes; viewtime++) {
		    if (Use[viewtime]) {
				FoundData.Orbits[orbit].ViewTimes[vt2] = OTD_Data->Orbits[orbit].ViewTimes[viewtime];
				vt2++;
		    }
		}
		free(Use);
		
		printf("Point coinc: Orbit %d, retained %ld of %ld view time granules\n", 
		    orbit, vt2, OTD_Data->Orbits[orbit].num_viewtimes);
	    	
    }
    
    /* Now recalculate the view time grids */
    
    for (orbit = 0; orbit < num_orbits; orbit++) {
		FoundData.Orbits[orbit].ViewTimeGrid = (int *)calloc(720*360, sizeof(int));
	 	FoundData.Orbits[orbit].ViewTimeGridStart = (double *)calloc(720*360, sizeof(double));
	 	FoundData.Orbits[orbit].ViewTimeGridEnd   = (double *)calloc(720*360, sizeof(double));
		for (idx = 0; idx < FoundData.Orbits[orbit].num_viewtimes; idx++) {
		    gridlon = LatLon2Grid(FoundData.Orbits[orbit].ViewTimes[idx].grid_point[0], 
					  FoundData.Orbits[orbit].ViewTimes[idx].grid_point[1],  0.5);
		    FoundData.Orbits[orbit].ViewTimeGrid[gridlon] +=
					    (int)(FoundData.Orbits[orbit].ViewTimes[idx].duration);
		    if (FoundData.Orbits[orbit].ViewTimeGridStart[gridlon] < 1) {
			FoundData.Orbits[orbit].ViewTimeGridStart[gridlon] = FoundData.Orbits[orbit].ViewTimes[idx].TAI93_start;
			FoundData.Orbits[orbit].ViewTimeGridEnd[gridlon]   = FoundData.Orbits[orbit].ViewTimes[idx].TAI93_start +
									 FoundData.Orbits[orbit].ViewTimes[idx].duration;
		    } else {
			if ((FoundData.Orbits[orbit].ViewTimes[idx].TAI93_start + FoundData.Orbits[orbit].ViewTimes[idx].duration) >
				FoundData.Orbits[orbit].ViewTimeGridEnd[gridlon])
				FoundData.Orbits[orbit].ViewTimeGridEnd[gridlon] = 
					(FoundData.Orbits[orbit].ViewTimes[idx].TAI93_start + FoundData.Orbits[orbit].ViewTimes[idx].duration);
		    }
		}
    }
    
    printf("Point coinc: Recalculated view time grids.\n");
    
    /* Trim down the point data set ... reject data out of bounds or with no view time 
     *		(crude pass on the view time, based on viewtime grids)
     */
     
     for (datum = 0; datum < Point_Data->num_point_data; datum++) {
		TimeOK = !Bounds->TimeWindow.Active;
		if (!TimeOK) {
		    TimeOK = ((Point_Data->Data[datum].DateTime.TAI93 >= Bounds->TimeWindow.Start.TAI93) &&
			      (Point_Data->Data[datum].DateTime.TAI93 <= Bounds->TimeWindow.End.TAI93));
		}
		PositionOK = !Bounds->AreaBound.Active;
		if (TimeOK && !PositionOK) 
		    PositionOK = CheckLocation(Point_Data->Data[datum].Position, Bounds);
		/*
		printf("%d %d %f %f\n",TimeOK,PositionOK,Point_Data->Data[datum].Position[0],Point_Data->Data[datum].Position[1]);
		*/ 
		if (!TimeOK || !PositionOK) {
		    Point_Data->Data[datum].Status = OUT_OF_BOUNDS;
		    Point_Data->Results.num_out_of_bounds++;
		} else {
		    gridlon = LatLon2Grid(Point_Data->Data[datum].Position[0], 
					  Point_Data->Data[datum].Position[1], 0.5);
		    orbit = GetOrbitByTime(OTD_Data, Point_Data->Data[datum].DateTime.TAI93);
		    if (orbit != -1) {
				dwelltime = FoundData.Orbits[orbit].ViewTimeGrid[gridlon];
				starttime = FoundData.Orbits[orbit].ViewTimeGridStart[gridlon];
				endtime   = FoundData.Orbits[orbit].ViewTimeGridEnd[gridlon];
		    } else {
				dwelltime = starttime = endtime = 0.0;
		    }
		    if ((dwelltime <= 0) || (Point_Data->Data[datum].DateTime.TAI93 <= starttime) ||
				(Point_Data->Data[datum].DateTime.TAI93 >= endtime)) {
			    Point_Data->Data[datum].Status = NOT_SEEN;
			    Point_Data->Results.num_not_seen++;
			} else {
			    Point_Data->Data[datum].Status = PENDING;
			    Point_Data->Results.num_seen++;
			}
		}
    }
     
    printf("Point coinc: After first reduction pass,  out of bounds: %ld\n", Point_Data->Results.num_out_of_bounds);
    printf("Point coinc:                                   not seen: %ld\n", Point_Data->Results.num_not_seen);
    printf("Point coinc:                                       seen: %ld\n", Point_Data->Results.num_seen);
     
    /* Must still recheck to make sure the point has been seen, as boom gaps and array geometry
     *    may still have left the region blind.  Only way to do this is brute force check viewtime
     *    granules for each point datum.  Fortunately,  the by-orbit splitting and (hopefully) bound
     *	  specification in the first pass should have reduced the number of point data and granules
     *    so that this operation is not too time-consuming.
     */
     
     Point_Data->Results.num_seen = 0;
     
     for (datum = 0; datum < Point_Data->num_point_data; datum++) {
		 if (Point_Data->Data[datum].Status == PENDING) {
		     SetAreaBound(&SmallBounds, 
				   CIRCLE, Point_Data->Data[datum].Position[0], 
				           Point_Data->Data[datum].Position[1], 0, Parameters.range_error_km);
		     orbit = 0;
		     while ((Point_Data->Data[datum].Status == PENDING) && (orbit < num_orbits)) {
				 vt2 = 0;
				 while ((Point_Data->Data[datum].Status == PENDING) && (vt2 < FoundData.Orbits[orbit].num_viewtimes)) {
				     TimeOK =
				       (((Point_Data->Data[datum].DateTime.TAI93 + Parameters.time_error_sec) >= 
							FoundData.Orbits[orbit].ViewTimes[vt2].TAI93_start) &&
						((Point_Data->Data[datum].DateTime.TAI93 - Parameters.time_error_sec) <=
							(FoundData.Orbits[orbit].ViewTimes[vt2].TAI93_start +
							 FoundData.Orbits[orbit].ViewTimes[vt2].duration)));
				     if (TimeOK) {
						PositionOK = CheckLocation(FoundData.Orbits[orbit].ViewTimes[vt2].grid_point, 
									   &SmallBounds);
						if (PositionOK) {
						    Point_Data->Data[datum].Status = SEEN;
						    Point_Data->Results.num_seen++;
						} else {
						    vt2++;
						}
				     } else {
					 	vt2++;
				     }
				 }
				 if (Point_Data->Data[datum].Status != SEEN) orbit++;
		     }
		     if (Point_Data->Data[datum].Status == SEEN) 
		     		Point_Data->Data[datum].Orbit = orbit;
		     else					
		     		Point_Data->Results.num_not_seen++;
		 }
     }
     
    printf("Point coinc: After second reduction pass, out of bounds: %ld\n", Point_Data->Results.num_out_of_bounds);
    printf("Point coinc:                                   not seen: %ld\n", Point_Data->Results.num_not_seen);
    printf("Point coinc:                                       seen: %ld\n", Point_Data->Results.num_seen);
 
     /* Now ready to do the coincidence check.  Fortunately, we know exactly which orbits to look in,
      *   based on the point data view time granules...
      */

    fraction_done = 0.0;
    next_fraction = 0.1;
    num_data_checked = 0;

    for (datum = 0; datum < Point_Data->num_point_data; datum++) {
		if (Point_Data->Data[datum].Status == SEEN) {
		    Point_xyt.loc.Latitude = Point_Data->Data[datum].Position[0];
		    Point_xyt.loc.Longitude = Point_Data->Data[datum].Position[1];
		    Point_xyt.time = Point_Data->Data[datum].DateTime.TAI93;
		    Point_Data->Data[datum].Time_error = 1e9;
		    Point_Data->Data[datum].Range_error = 1e9;
		    
		    switch (Parameters.data_level) {
				case A: {
				    break;
				}
				case F: {
				    orbit = Point_Data->Data[datum].Orbit;
		
				    for (area = OTD_Data->Orbits[orbit].FirstArea;
					    area < OTD_Data->Orbits[orbit].FirstArea+OTD_Data->Orbits[orbit].Areas_Accepted; area++) {
			
						for (flash = OTD_Data->Areas[area].FirstFlash;
							flash < OTD_Data->Areas[area].FirstFlash+OTD_Data->Areas[area].Flashes_Accepted; flash++)  {
				
						    if (Parameters.time_to_use == FLASH_START_TIME) {
							OTD_xyt.time = OTD_Data->Flashes[flash].HDFFlash.TAI93;
						    } else {
							OTD_xyt.time = peak_group_time(flash, OTD_Data, &peak_rad);
						    }
						    OTD_xyt.loc.Latitude = OTD_Data->Flashes[flash].HDFFlash.cent[0];
						    OTD_xyt.loc.Longitude = OTD_Data->Flashes[flash].HDFFlash.cent[1];
						    
						    inbounds = CheckCoinc(Point_xyt, OTD_xyt, Parameters, &delt, &delr, &az);
						    
						    if (inbounds) {
							/* if (FlashOK(OTD_Data->Flashes[flash].HDFFlash, Bounds)) */ 
							    if (Parameters.crit_to_use == TIME) {
									if (fabs(delt) < fabs(Point_Data->Data[datum].Time_error)) {
									    Point_Data->Data[datum].Time_error = delt;
									    Point_Data->Data[datum].Range_error = delr;
									    Point_Data->Data[datum].Azimuth = az;
									    Point_Data->Data[datum].OTD_datum_index = flash;
									    Point_Data->Data[datum].Status = FOUND;
									}
							    } else {
									if (delr < Point_Data->Data[datum].Range_error) {
									    Point_Data->Data[datum].Time_error = delt;
									    Point_Data->Data[datum].Range_error = delr;
									    Point_Data->Data[datum].Azimuth = az;
									    Point_Data->Data[datum].OTD_datum_index = flash;
									    Point_Data->Data[datum].Status = FOUND;
									}
							    }
						    }
						}
				    }
				    break;
				}
				case G: {
				    break;
				}
				case E: {
				    break;
				}
		    }
		    if (Point_Data->Data[datum].Status == FOUND) {
				Point_Data->Results.num_found++;
		    } else {
		    	Point_Data->Data[datum].Status = NOT_FOUND;
				Point_Data->Results.num_not_found++;
		    }
		    num_data_checked++;
		    fraction_done = (float)num_data_checked/(float)Point_Data->Results.num_seen;
		    if (fraction_done > next_fraction) {
		        found_fraction = (float)Point_Data->Results.num_found/(float)(
					Point_Data->Results.num_found+Point_Data->Results.num_not_found);
				printf("Point coinc: %5.0f percent done... %5.0f percent found\n", next_fraction*100.0, 
				found_fraction*100.0);
				next_fraction += 0.1;
		    }
		}
    }
}

int CheckCoinc(aPoint, OTD, Params, delt, delr, az)
struct anXYTtriplet	aPoint, OTD;
struct aCoincParamset	Params;
double *delt, *delr, *az;
{
    double faz, baz, rg;
    *delt = 1e9;
    *delr = 1e9;
    
    *delt = (OTD.time - aPoint.time);
    if (fabs(*delt) <= Params.time_error_sec) {
	LatLons2RgAz(aPoint.loc.Latitude, aPoint.loc.Longitude, 
		     OTD.loc.Latitude, OTD.loc.Longitude, 
		     &faz, &baz, &rg);
	*delr = rg / 1e3;
	*az = faz;
	return(*delr <= Params.range_error_km);
    } else {
	return(FALSE);
    }
}

int GetOrbitByTime(OTD, TAI93)
struct anOTDDataset *OTD;
double TAI93;
{
    int orbit = 0, found=FALSE;
    
    while ((orbit < OTD->num_orbits) && !found) {
	found = ((TAI93 >= OTD->Orbits[orbit].Attributes.TAI93_start) && 
		 (TAI93 <= OTD->Orbits[orbit].Attributes.TAI93_end));
	orbit++;
    }
    if (found) orbit--;
    if (!found) orbit = -1;
    return(orbit);
}

void LoadPointDataFile(filename,PointData,DFInfo,OTDData,Bounds)
char filename[128];
struct aPointDataset *PointData;
struct anASCIIDataFileAttributeSet	DFInfo;
struct anOTDDataset  *OTDData;
struct anOTDBoundset *Bounds;
{
	int 		  	num_cols, TimeOK, PositionOK;
	long		  	file_size, datum, datum2, num_valid = 0;
	struct 			aPointDataset TempPointData;
	FILE			*ptfile;		
	int				col;
	char			formatstr[128], aline[128];
	double			val[20];
	extern int		fgetaline();
	
	num_cols = DFInfo.num_cols;
	for (col=0; col<num_cols; col++) {
		DFInfo.HadFields.has_year = (DFInfo.HadFields.has_year || DFInfo.HadFields.has_fixed_year || (DFInfo.content[col]==YEAR));
		DFInfo.HadFields.has_month = (DFInfo.HadFields.has_month || DFInfo.HadFields.has_fixed_month || (DFInfo.content[col]==MONTH));
		DFInfo.HadFields.has_day  = (DFInfo.HadFields.has_day || DFInfo.HadFields.has_fixed_day || (DFInfo.content[col]==DAY));
		DFInfo.HadFields.has_hour = (DFInfo.HadFields.has_hour || (DFInfo.content[col]==HOUR));
		DFInfo.HadFields.has_minute = (DFInfo.HadFields.has_minute || (DFInfo.content[col]==MINUTE));
		DFInfo.HadFields.has_second = (DFInfo.HadFields.has_second || (DFInfo.content[col]==SECOND));
		DFInfo.HadFields.has_doy = (DFInfo.HadFields.has_doy || DFInfo.HadFields.has_fixed_doy || (DFInfo.content[col]==DOY));
		DFInfo.HadFields.has_TAI93 = (DFInfo.HadFields.has_TAI93 || 
							 ((DFInfo.content[col]==TAI93_TIME) || (DFInfo.content[col]==GPS_TIME)));
		DFInfo.HadFields.has_latitude = (DFInfo.HadFields.has_latitude || (DFInfo.content[col]==LATITUDE));
		DFInfo.HadFields.has_longitude = (DFInfo.HadFields.has_longitude || (DFInfo.content[col]==LONGITUDE));
	}
	
	DFInfo.HadFields.has_ymd = (DFInfo.HadFields.has_year && DFInfo.HadFields.has_month && DFInfo.HadFields.has_day);
	DFInfo.HadFields.has_hms = (DFInfo.HadFields.has_hour);
	DFInfo.HadFields.has_fulltime = ((DFInfo.HadFields.has_ymd && DFInfo.HadFields.has_hms) || 
							(DFInfo.HadFields.has_year && DFInfo.HadFields.has_doy && DFInfo.HadFields.has_hms) || (DFInfo.HadFields.has_TAI93));
	
	if (!(DFInfo.HadFields.has_latitude && DFInfo.HadFields.has_longitude)) {
		fprintf(stderr,"No spatial coordinate (lat/lon) columns specified for point data file '%s'\n",filename);
		exit(-1);
	}
	if (!DFInfo.HadFields.has_fulltime) {
		fprintf(stderr,"Full date/time field not specified for point data file '%s'; use either full UTC or TAI93\n",filename);
		exit(-1);
	}
	
	
	if ((ptfile=fopen(filename,"r"))==NULL) {
		fprintf(stderr,"Error opening point data file '%s' for input.\n");
		exit(-1);
	}
	GetFileSize(ptfile, &file_size);
	rewind(ptfile);
	TempPointData.Data = (struct aPointDatum *)calloc(file_size,sizeof(struct aPointDatum));
	
	strcpy(formatstr,"%f");

	for (col = 1; col < num_cols; col++) {
		strcat(formatstr," %f");
	}
	printf("Using format string '%s'\n",formatstr);
	
	datum = 0;
	while (fgetaline(aline, 128, ptfile)) {
		switch (num_cols) {
			case 1: {
				sscanf(aline,formatstr,&val[0]);
				break;
			}
			case 2: {
				sscanf(aline,formatstr,&val[0],&val[1]);
				break;
			}
			case 3: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2]);
				break;
			}
			case 4: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3]);
				break;
			}
			case 5: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4]);
				break;
			}
			case 6: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5]);
				break;
			}
			case 7: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6]);
				break;
			}
			case 8: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7]);
				break;
			}
			case 9: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8]);
				break;
			}	
			case 10: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9]);
				break;
			}
			case 11: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10]);
				break;
			}
			case 12: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11]);
				break;
			}
			case 13: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12]);
				break;
			}
			case 14: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13]);
				break;
			}
			case 15: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14]);
				break;
			}
			case 16: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15]);
				break;
			}
			case 17: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16]);
				break;
			}
			case 18: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16],&val[17]);
				break;
			}
			case 19: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16],&val[17],&val[18]);
				break;
			}
			case 20: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16],&val[17],&val[18],&val[19]);
				break;
			}
		}
		
		for (col = 0; col < num_cols; col++) {
			switch(DFInfo.content[col]) {
				case	YEAR: {
					if ((val[col] > 50) && (val[col] < 100)) val[col] += 1900;
					TempPointData.Data[datum].DateTime.UTC.year  = (int)val[col];
					break;
				}
				case	MONTH: {
					TempPointData.Data[datum].DateTime.UTC.month = (int)val[col];
					break;
				}
				case 	DAY: {
					TempPointData.Data[datum].DateTime.UTC.day   = (int)val[col];
					break;
				}
				case 	HOUR: {
					TempPointData.Data[datum].DateTime.UTC.hour  = (int)val[col];
					break;
				}
				case	MINUTE: {
					TempPointData.Data[datum].DateTime.UTC.minute = (int)val[col];
					break;
				}
				case	SECOND: {
					TempPointData.Data[datum].DateTime.UTC.second = val[col];
					break;
				}
				case	DOY:	 {
					TempPointData.Data[datum].DateTime.UTC.doy	  = (int)val[col];
					break;
				}
				case	TAI93_TIME:	 {
					TempPointData.Data[datum].DateTime.TAI93	  = val[col];
					break;
				}
				case	GPS_TIME:	 {
					TempPointData.Data[datum].DateTime.TAI93	  = val[col] + GPS_to_TAI93;
					break;
				}
				case	LATITUDE:	 {
					TempPointData.Data[datum].Position[0] 		  = (float)val[col];
					break;
				}
				case	LONGITUDE:	 {
					TempPointData.Data[datum].Position[1]		  = (float)val[col];
					break;
				}
				case	INHERITED0:	 {
					TempPointData.Data[datum].Inherited[0]		  = val[col];
					break;
				}
				case	INHERITED1:	 {
					TempPointData.Data[datum].Inherited[1]		  = val[col];
					break;
				}
				case	INHERITED2:	 {
					TempPointData.Data[datum].Inherited[2]		  = val[col];
					break;
				}
				case	INHERITED3:	 {
					TempPointData.Data[datum].Inherited[3]		  = val[col];
					break;
				}
				case	INHERITED4:	 {
					TempPointData.Data[datum].Inherited[4]		  = val[col];
					break;
				}
				case	DUMMY:	 {
					break;
				}
			}
		}
		if (DFInfo.HadFields.has_fixed_year) TempPointData.Data[datum].DateTime.UTC.year = DFInfo.HadFields.fixed_year;
		if (DFInfo.HadFields.has_fixed_month) TempPointData.Data[datum].DateTime.UTC.month = DFInfo.HadFields.fixed_month;
		if (DFInfo.HadFields.has_fixed_day) TempPointData.Data[datum].DateTime.UTC.day = DFInfo.HadFields.fixed_day;
		if (DFInfo.HadFields.has_fixed_doy) TempPointData.Data[datum].DateTime.UTC.doy = DFInfo.HadFields.fixed_doy;
		if (DFInfo.HadFields.has_hour && !DFInfo.HadFields.has_minute && !DFInfo.HadFields.has_second) {
			TempPointData.Data[datum].DateTime.UTC.minute = 0;
			TempPointData.Data[datum].DateTime.UTC.second = 0;
		} else if (DFInfo.HadFields.has_hour && DFInfo.HadFields.has_minute && !DFInfo.HadFields.has_second) {
			TempPointData.Data[datum].DateTime.UTC.second = 0;
		}
		
		if (DFInfo.HadFields.has_TAI93) {
			TempPointData.Data[datum].DateTime.UTC = 
				TAI93_to_UTC(TempPointData.Data[datum].DateTime.TAI93);
		} else {
			if (DFInfo.HadFields.has_ymd && !DFInfo.HadFields.has_doy) {
				TempPointData.Data[datum].DateTime.UTC.doy = 
					getDayOfYear(TempPointData.Data[datum].DateTime.UTC.day,
								 TempPointData.Data[datum].DateTime.UTC.month,
								 TempPointData.Data[datum].DateTime.UTC.year);
				TempPointData.Data[datum].DateTime.TAI93 =
					UTC_to_TAI93(TempPointData.Data[datum].DateTime.UTC);
			} else {
				if (DFInfo.HadFields.has_year && DFInfo.HadFields.has_doy && !DFInfo.HadFields.has_ymd) {
					InvJulian(TempPointData.Data[datum].DateTime.UTC.year,
							  TempPointData.Data[datum].DateTime.UTC.doy,
							  &TempPointData.Data[datum].DateTime.UTC.month,
							  &TempPointData.Data[datum].DateTime.UTC.day);
					TempPointData.Data[datum].DateTime.TAI93 =
						UTC_to_TAI93(TempPointData.Data[datum].DateTime.UTC);
				}
			}								 
			if (DFInfo.HadFields.has_ymd && DFInfo.HadFields.has_hms) {
				TempPointData.Data[datum].DateTime.TAI93 =
					UTC_to_TAI93(TempPointData.Data[datum].DateTime.UTC);
			} else {
				fprintf(stderr,"Error filling out the date/time fields on input from point data file '%s'\n",filename);
				exit(-1);
			}
		}
		TempPointData.Data[datum].Status = PENDING;
		TempPointData.Data[datum].Orbit  = GetOrbitByTime(OTDData, TempPointData.Data[datum].DateTime.TAI93);
		if (TempPointData.Data[datum].Orbit == -1) {
			TempPointData.Data[datum].Status = NOT_SEEN;
		} else {
			TimeOK = !Bounds->TimeWindow.Active;
			if (!TimeOK) {
			    TimeOK = ((TempPointData.Data[datum].DateTime.TAI93 >= Bounds->TimeWindow.Start.TAI93) &&
				          (TempPointData.Data[datum].DateTime.TAI93 <= Bounds->TimeWindow.End.TAI93));
			}
			PositionOK = !Bounds->AreaBound.Active;
			if (TimeOK && !PositionOK) 
		    	PositionOK = CheckLocation(TempPointData.Data[datum].Position, Bounds);
			if (!TimeOK || !PositionOK) {
			    TempPointData.Data[datum].Status = OUT_OF_BOUNDS;
			}
		}
		if (TempPointData.Data[datum].Status == PENDING) num_valid++;
		datum++;
	}
	PointData->Data = (struct aPointDatum *)calloc(num_valid,sizeof(struct aPointDatum));
	datum2 = 0;
	for (datum = 0; datum < file_size; datum++) {
		if (TempPointData.Data[datum].Status == PENDING) {
			memcpy(&PointData->Data[datum2],&TempPointData.Data[datum],sizeof(struct aPointDatum));
			/*
				printf("%10.3lf  %6.2f  %6.2f  %10.3lf  %6.2f  %6.2f\n",
				TempPointData.Data[datum].DateTime.TAI93,
				TempPointData.Data[datum].Position[0],
				TempPointData.Data[datum].Position[1],
				PointData->Data[datum2].DateTime.TAI93,
				PointData->Data[datum2].Position[0],
				PointData->Data[datum2].Position[1]);
			*/
			/*
			PointData->Data[datum2].DateTime = TempPointData.Data[datum].DateTime;
			PointData->Data[datum2].Position[0] = TempPointData.Data[datum].Position[0];
			PointData->Data[datum2].Position[1] = TempPointData.Data[datum].Position[1];
			for (i=0; i<4; i++) 
				PointData->Data[datum2].Inherited[i] = TempPointData.Data[datum].Inherited[i];
			*/
			datum2++;
		}
	}
	PointData->num_point_data = num_valid;
	free(TempPointData.Data);
	printf("Accepted %ld of %ld point data values to check against this OTD dataset and bounds\n",
		num_valid,file_size);
	fclose(ptfile);
	return;
}

void SetASCIIDataFileColumn(DFInfo, col, param)
struct anASCIIDataFileAttributeSet *DFInfo;
int col;
enum ascii_data_value param;
{
	if (col < 1) {
		fprintf(stderr,"Error in SetASCIIDataFileColumn() - column number must be > 0\n");
		exit(-1);
	}
	DFInfo->content[col-1] = param;
	if (col > (DFInfo->num_cols)) DFInfo->num_cols = col;
}

void FixASCIIDataFileValue(DFInfo, param, value)
struct anASCIIDataFileAttributeSet *DFInfo;
int value;
enum ascii_data_value param;
{
	if ((param != YEAR) && (param != MONTH) &&
	 	(param != DAY)  && (param != DOY)) {
	 		fprintf(stderr,"Error in FixASCIIDataFileValue() ... cannot fix this field.\n");
	 		exit(-1);
	 }
	 
	switch (param) {
		case YEAR: {
			if ((value > 50) && (value < 100)) value += 1900;
			DFInfo->HadFields.fixed_year = value;
			DFInfo->HadFields.has_fixed_year   = TRUE;
			break;
		}
		case MONTH: {
			DFInfo->HadFields.fixed_month = value;
			DFInfo->HadFields.has_fixed_month   = TRUE;
			break;
		}
		case DAY: {
			DFInfo->HadFields.fixed_day = value;
			DFInfo->HadFields.has_fixed_day = TRUE;
			break;
		}
		case DOY: {
			DFInfo->HadFields.fixed_doy = value;
			DFInfo->HadFields.has_fixed_doy = TRUE;
			break;
		}
	}
}

void LoadXYTDataFile(filename, XYTData, DFInfo)
char filename[128];
struct anXYTDataset *XYTData;
struct anASCIIDataFileAttributeSet DFInfo;
{
	int 		  	num_cols;
	long		  	file_size, datum, datum2, num_valid = 0;
	struct 			anXYTDataset TempXYTData;
	FILE			*xytfile;		
	int				col;
	char			formatstr[128], aline[128];
	double			val[20];
	
	sprintf(XYTData->filename,"%s",filename);

	num_cols = DFInfo.num_cols;
	for (col=0; col<num_cols; col++) {
		DFInfo.HadFields.has_year = (DFInfo.HadFields.has_year || DFInfo.HadFields.has_fixed_year || (DFInfo.content[col]==YEAR));
		DFInfo.HadFields.has_month = (DFInfo.HadFields.has_month || DFInfo.HadFields.has_fixed_month || (DFInfo.content[col]==MONTH));
		DFInfo.HadFields.has_day  = (DFInfo.HadFields.has_day || DFInfo.HadFields.has_fixed_day || (DFInfo.content[col]==DAY));
		DFInfo.HadFields.has_hour = (DFInfo.HadFields.has_hour || (DFInfo.content[col]==HOUR));
		DFInfo.HadFields.has_minute = (DFInfo.HadFields.has_minute || (DFInfo.content[col]==MINUTE));
		DFInfo.HadFields.has_second = (DFInfo.HadFields.has_second || (DFInfo.content[col]==SECOND));
		DFInfo.HadFields.has_doy = (DFInfo.HadFields.has_doy || DFInfo.HadFields.has_fixed_doy || (DFInfo.content[col]==DOY));
		DFInfo.HadFields.has_TAI93 = (DFInfo.HadFields.has_TAI93 || 
							 ((DFInfo.content[col]==TAI93_TIME) || (DFInfo.content[col]==GPS_TIME)));
		DFInfo.HadFields.has_latitude = (DFInfo.HadFields.has_latitude || (DFInfo.content[col]==LATITUDE));
		DFInfo.HadFields.has_longitude = (DFInfo.HadFields.has_longitude || (DFInfo.content[col]==LONGITUDE));
	}
	DFInfo.HadFields.has_ymd = (DFInfo.HadFields.has_year && DFInfo.HadFields.has_month && DFInfo.HadFields.has_day);
	DFInfo.HadFields.has_hms = (DFInfo.HadFields.has_hour);
	DFInfo.HadFields.has_fulltime = ((DFInfo.HadFields.has_ymd && DFInfo.HadFields.has_hms) || 
							(DFInfo.HadFields.has_year && DFInfo.HadFields.has_doy && DFInfo.HadFields.has_hms) || (DFInfo.HadFields.has_TAI93));
  	if (!(DFInfo.HadFields.has_latitude && DFInfo.HadFields.has_longitude)) {
		fprintf(stderr,"No spatial coordinate (lat/lon) columns specified for XYT data file '%s'\n",filename);
		exit(-1);
	}
	if (!DFInfo.HadFields.has_fulltime) {
		fprintf(stderr,"Full date/time field not specified for XYT data file '%s'; use either full UTC or TAI93\n",filename);
		exit(-1);
	}
	printf("Opening %s\n", filename);
	if ((xytfile=fopen(filename,"r"))==NULL) {
		fprintf(stderr,"Error opening XYT data file '%s' for input.\n");
		exit(-1);
	}
	printf("Getting file size for %s\n", filename);
	GetFileSize(xytfile, &file_size);
	puts("Returned");
	rewind(xytfile);
	printf("Allocating space for %ld lines\n", file_size);
	TempXYTData.Raw = (struct anXYTDatum *)calloc(file_size,sizeof(struct anXYTDatum));

	sprintf(formatstr,"\0");
	strcpy(formatstr,"%f");

	for (col = 1; col < num_cols; col++) {
		strcat(formatstr," %f");
	}
	printf("Using format string '%s'\n",formatstr);
	
	datum = 0;
	while (fgetaline(aline, 128, xytfile)) {
		switch (num_cols) {
			case 1: {
				sscanf(aline,formatstr,&val[0]);
				break;
			}
			case 2: {
				sscanf(aline,formatstr,&val[0],&val[1]);
				break;
			}
			case 3: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2]);
				break;
			}
			case 4: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3]);
				break;
			}
			case 5: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4]);
				break;
			}
			case 6: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5]);
				break;
			}
			case 7: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6]);
				break;
			}
			case 8: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7]);
				break;
			}
			case 9: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8]);
				break;
			}	
			case 10: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9]);
				break;
			}
			case 11: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10]);
				break;
			}
			case 12: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11]);
				break;
			}
			case 13: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12]);
				break;
			}
			case 14: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13]);
				break;
			}
			case 15: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14]);
				break;
			}
			case 16: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15]);
				break;
			}
			case 17: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16]);
				break;
			}
			case 18: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16],&val[17]);
				break;
			}
			case 19: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16],&val[17],&val[18]);
				break;
			}
			case 20: {
				sscanf(aline,formatstr,&val[0],&val[1],&val[2],&val[3],&val[4],&val[5],&val[6],&val[7],
									   &val[8],&val[9],&val[10],&val[11],&val[12],&val[13],&val[14],&val[15],
									   &val[16],&val[17],&val[18],&val[19]);
				break;
			}
		}
		
		for (col = 0; col < num_cols; col++) {
			switch(DFInfo.content[col]) {
				case	YEAR: {
					if ((val[col] > 50) && (val[col] < 100)) val[col] += 1900;
					TempXYTData.Raw[datum].DateTime.UTC.year  = (int)val[col];
					break;
				}
				case	MONTH: {
					TempXYTData.Raw[datum].DateTime.UTC.month = (int)val[col];
					break;
				}
				case 	DAY: {
					TempXYTData.Raw[datum].DateTime.UTC.day   = (int)val[col];
					break;
				}
				case 	HOUR: {
					TempXYTData.Raw[datum].DateTime.UTC.hour  = (int)val[col];
					break;
				}
				case	MINUTE: {
					TempXYTData.Raw[datum].DateTime.UTC.minute = (int)val[col];
					break;
				}
				case	SECOND: {
					TempXYTData.Raw[datum].DateTime.UTC.second = val[col];
					break;
				}
				case	DOY:	 {
					TempXYTData.Raw[datum].DateTime.UTC.doy	  = (int)val[col];
					break;
				}
				case	TAI93_TIME:	 {
					TempXYTData.Raw[datum].DateTime.TAI93	  = val[col];
					break;
				}
				case	GPS_TIME:	 {
					TempXYTData.Raw[datum].DateTime.TAI93	  = val[col] + GPS_to_TAI93;
					break;
				}
				case	LATITUDE:	 {
					TempXYTData.Raw[datum].Position[0] 		  = (float)val[col];
					break;
				}
				case	LONGITUDE:	 {
					TempXYTData.Raw[datum].Position[1]		  = (float)val[col];
					break;
				}
				case	INHERITED0:	 {
					TempXYTData.Raw[datum].Inherited[0]		  = val[col];
					break;
				}
				case	INHERITED1:	 {
					TempXYTData.Raw[datum].Inherited[1]		  = val[col];
					break;
				}
				case	INHERITED2:	 {
					TempXYTData.Raw[datum].Inherited[2]		  = val[col];
					break;
				}
				case	INHERITED3:	 {
					TempXYTData.Raw[datum].Inherited[3]		  = val[col];
					break;
				}
				case	INHERITED4:	 {
					TempXYTData.Raw[datum].Inherited[4]		  = val[col];
					break;
				}
				case  	ELEVATION:	{
					TempXYTData.Raw[datum].Elevation		  = val[col];
					break;
				}
				case	DUMMY:	 {
					break;
				}
			}
		}
		if (DFInfo.HadFields.has_fixed_year) TempXYTData.Raw[datum].DateTime.UTC.year = DFInfo.HadFields.fixed_year;
		if (DFInfo.HadFields.has_fixed_month) TempXYTData.Raw[datum].DateTime.UTC.month = DFInfo.HadFields.fixed_month;
		if (DFInfo.HadFields.has_fixed_day) TempXYTData.Raw[datum].DateTime.UTC.day = DFInfo.HadFields.fixed_day;
		if (DFInfo.HadFields.has_fixed_doy) TempXYTData.Raw[datum].DateTime.UTC.doy = DFInfo.HadFields.fixed_doy;
		if (DFInfo.HadFields.has_hour && !DFInfo.HadFields.has_minute && !DFInfo.HadFields.has_second) {
			TempXYTData.Raw[datum].DateTime.UTC.minute = 0;
			TempXYTData.Raw[datum].DateTime.UTC.second = 0;
		} else if (DFInfo.HadFields.has_hour && DFInfo.HadFields.has_minute && !DFInfo.HadFields.has_second) {
			TempXYTData.Raw[datum].DateTime.UTC.second = 0;
		}
		
		if (DFInfo.HadFields.has_TAI93) {
			TempXYTData.Raw[datum].DateTime.UTC = 
				TAI93_to_UTC(TempXYTData.Raw[datum].DateTime.TAI93);
		} else {
			if (DFInfo.HadFields.has_ymd && !DFInfo.HadFields.has_doy) {
				TempXYTData.Raw[datum].DateTime.UTC.doy = 
					getDayOfYear(TempXYTData.Raw[datum].DateTime.UTC.day,
								 TempXYTData.Raw[datum].DateTime.UTC.month,
								 TempXYTData.Raw[datum].DateTime.UTC.year);
				TempXYTData.Raw[datum].DateTime.TAI93 =
					UTC_to_TAI93(TempXYTData.Raw[datum].DateTime.UTC);
			} else {
				if (DFInfo.HadFields.has_year && DFInfo.HadFields.has_doy && !DFInfo.HadFields.has_ymd) {
					InvJulian(TempXYTData.Raw[datum].DateTime.UTC.year,
							  TempXYTData.Raw[datum].DateTime.UTC.doy,
							  &TempXYTData.Raw[datum].DateTime.UTC.month,
							  &TempXYTData.Raw[datum].DateTime.UTC.day);
					TempXYTData.Raw[datum].DateTime.TAI93 =
						UTC_to_TAI93(TempXYTData.Raw[datum].DateTime.UTC);
				}
			}								 
			if (DFInfo.HadFields.has_ymd && DFInfo.HadFields.has_hms) {
				TempXYTData.Raw[datum].DateTime.TAI93 =
					UTC_to_TAI93(TempXYTData.Raw[datum].DateTime.UTC);
			} else {
				if (DFInfo.HadFields.has_year && DFInfo.HadFields.has_doy && DFInfo.HadFields.has_hms) {
					InvJulian(TempXYTData.Raw[datum].DateTime.UTC.year, TempXYTData.Raw[datum].DateTime.UTC.doy,
						  &TempXYTData.Raw[datum].DateTime.UTC.month, &TempXYTData.Raw[datum].DateTime.UTC.day);
					TempXYTData.Raw[datum].DateTime.TAI93 = 
					UTC_to_TAI93(TempXYTData.Raw[datum].DateTime.UTC);
				} else {
					fprintf(stderr,"Error filling out the date/time fields on input from TempXYTData.Raw data file '%s'\n",filename);
					exit(-1);
				}
			}
		}
		datum++;
	}
	printf("Closing file %s\n", filename);
	if (fclose(xytfile)==EOF) {
	    fprintf(stderr, "Error closing file %s\n", filename);
	    exit(-1);
	}

	XYTData->Raw = (struct anXYTDatum *)calloc(file_size,sizeof(struct anXYTDatum));
	datum2 = 0;
	for (datum = 0; datum < file_size; datum++) {
		printf("Load track data: %10.3f\n",TempXYTData.Raw[datum].DateTime.TAI93);
		if (datum==0) {
			memcpy(&XYTData->Raw[datum2],&TempXYTData.Raw[datum],sizeof(struct anXYTDatum));
			datum2++;
		} else {
			if (TempXYTData.Raw[datum].DateTime.TAI93 < TempXYTData.Raw[datum-1].DateTime.TAI93) {
				fprintf(stderr,"Error reading XYT data file '%s', line %d is out of time sequence!\n",
							filename,datum);
				exit(-1);
			} else {
				memcpy(&XYTData->Raw[datum2],&TempXYTData.Raw[datum],sizeof(struct anXYTDatum));
				datum2++;
			}
		}
	}
	XYTData->num_raw = datum2;
	free(TempXYTData.Raw);
	printf("Accepted %ld of %ld XYT data values to check against this OTD dataset and bounds\n",
		datum2,file_size);
	return;
}

int	XYTInterp(XYT, TAI93, Out)
struct anXYTDataset *XYT;
double TAI93;
struct anXYTDatum *Out;
{
	double frac, faz, baz, rg, delval, outlat, outlon;
	long	   j, index, prev, num_raw;
	
	num_raw = XYT->num_raw;
	
	if (num_raw <= 0) {
		fprintf(stderr,"Error in XYTInterp: passed XYT data set has only %d values\n",num_raw);
		exit(-1);
	}
	if ((TAI93 < (XYT->Raw[0].DateTime.TAI93)) || (TAI93 > (XYT->Raw[num_raw-1].DateTime.TAI93)))
		 return(FAIL);
	    
	index = 0;
	while ((XYT->Raw[index].DateTime.TAI93 < TAI93) &&
		   (index < num_raw)) 
		   {
		   	index++;
		   	}
		   
	prev = index-1;
	
	if ((prev < 0) || (index < 0) || (prev >= num_raw) || (index >= num_raw)) 
		return(FAIL);
	
	frac = (TAI93 - XYT->Raw[prev].DateTime.TAI93) /
		   (XYT->Raw[index].DateTime.TAI93 - XYT->Raw[prev].DateTime.TAI93);
		   
	LatLons2RgAz(XYT->Raw[prev].Position[0], XYT->Raw[prev].Position[1],
				 XYT->Raw[index].Position[0], XYT->Raw[index].Position[1],
				 &faz, &baz, &rg);
				 
	rg *= frac;
	
	RgAz2LatLon(XYT->Raw[prev].Position[0], XYT->Raw[prev].Position[1],
				 &outlat, &outlon,
				 faz, &baz, rg);
	Out->Position[0] = (float)outlat;
	Out->Position[1] = (float)outlon;
	Out->DateTime.TAI93 = TAI93;
	
	for (j = 0; j < 4; j++) {
		delval = XYT->Raw[index].Inherited[j] - XYT->Raw[prev].Inherited[j];
		{
			Out->Inherited[j] = XYT->Raw[prev].Inherited[j] +
								frac * delval;
		}
	}
	delval = XYT->Raw[index].Elevation - XYT->Raw[prev].Elevation;
	Out->Elevation = XYT->Raw[prev].Elevation + frac*delval;

	return(TRUE);
}

int	CheckXYT(lat,lon,TAI93,Bounds)
double lat, lon, TAI93;
struct anOTDBoundset *Bounds;
{
	int retval;
	struct anXYTDatum 	TestXYT;
	struct anOTDBoundset SmallBounds;
	float  grid_point[2];
	int		XYTOK = FALSE;
	double testTAI93;

	grid_point[0] = (float)lat;
	grid_point[1] = (float)lon;
	
	if (Bounds->XYTBound.timeslopres_sec <= 0) Bounds->XYTBound.timeslopres_sec = 10.0;
	
	switch(Bounds->XYTBound.XYT_bound_type) {
		case TRACK: {
                   for (testTAI93 = (TAI93 - Bounds->XYTBound.timeslop_sec);
			testTAI93 <= (TAI93 + Bounds->XYTBound.timeslop_sec);
			testTAI93 += Bounds->XYTBound.timeslopres_sec) {
			   retval = XYTInterp(Bounds->XYTBound.XYT, testTAI93, &TestXYT);
			   /* printf("%d  %12.3lf  %7.2lf %7.2lf\n", retval, testTAI93, 
				    TestXYT.Position[0], TestXYT.Position[1]); */
			   if (retval != FAIL) {
				SetAreaBound(&SmallBounds, CIRCLE, 
				TestXYT.Position[0], TestXYT.Position[1], 
				0, Bounds->XYTBound.max_range_km);
				XYTOK = (XYTOK || (CheckLocation(grid_point,&SmallBounds) &&
					(TestXYT.Elevation >= Bounds->XYTBound.min_elev) && 
					(TestXYT.Elevation <= Bounds->XYTBound.max_elev)));	
			   } else {
				fprintf(stderr,"Interpolation error at %10.3f\n",TAI93);
				XYTOK = 0;
			   }
		   }
		   break;
		}
		case PTOBS: {			
			break;
		}
	}
	return(XYTOK);
}
