/* LIS */

#define lis_operation_SUCCESSFUL		0x00000000

#define lis_operation_FAIL			0x80000000
#define lis_Hopen_FAIL			0x40000000
#define lis_SDstart_FAIL			0x20000000
#define lis_SDselect_FAIL			0x10000000
#define lis_Vgroup_Create_FAIL		0x08000000
#define lis_Vinsert_FAIL			0x04000000
#define lis_VSsetfields_FAIL		0x02000000
#define lis_area_VSattach_FAIL		0x01000000
#define lis_flash_VSattach_FAIL		0x00800000
#define lis_group_VSattach_FAIL		0x00400000
#define lis_event_VSattach_FAIL		0x00200000
#define lis_point_summary_VSattach_FAIL	0x00100000
#define lis_viewtime_VSattach_FAIL		0x00080000
#define lis_bg_summary_VSattach_FAIL	0x00040000
#define lis_orbit_summary_VSattach_FAIL	0x00020000
#define lis_one_second_VSattach_FAIL	0x00010000

#define lis_bg_orbit_summary_VSattach_FAIL	0x00008000
#define lis_bg_info_VSattach_FAIL		0x00004000
#define lis_bg_data_summary_VSattach_FAIL	0x00002000
#define lis_Vstart_FAIL			0x00001000
#define lis_MAX_FILE_FAIL			0x00000800

#define lis_inventory_metadata_FAIL		0x00000400
#define lis_archived_metadata_FAIL		0x00000200

#define lis_VSwrite_FAIL			0x00000100
#define lis_SDwritedata_FAIL		0x00000080
#define lis_VSread_FAIL			0x00000040
#define lis_SDreaddata_FAIL			0x00000020
#define lis_VEOF				0x00000010
#define lis_VSseek_FAIL			0x00000008

#define lis_NoMetadata (lis_operation_FAIL|lis_inventory_metadata_FAIL|lis_archived_metadata_FAIL)
#define lis_MissingVdata (lis_VSsetfields_FAIL)
#define lis_NoMetadataMissingVdata (lis_NoMetadata | lis_MissingVdata)

/* OTD */

#define otd_SUCCESS 0
#define otd_Hopen_FAIL			0x80000000
#define otd_SDstart_FAIL			0x40000000
#define otd_SDselect_FAIL			0x20000000
#define otd_area_vg_search_FAIL		0x10000000
#define otd_flash_vg_search_FAIL		0x08000000
#define otd_group_vg_search_FAIL		0x04000000
#define otd_event_vg_search_FAIL		0x02000000
#define otd_browse_vg_search_FAIL		0x0100000
#define otd_orbit_summary_vg_search_FAIL 	0x00800000
#define otd_flash_density_vg_search_FAIL	0x00400000
#define otd_area_VSattach_FAIL		0x00200000
#define otd_flash_VSattach_FAIL		0x00100000
#define otd_group_VSattach_FAIL		0x00080000
#define otd_event_VSattach_FAIL		0x00040000
#define otd_browse_VSattach_FAIL		0x00020000
#define otd_image_VSattach_FAIL		0x00010000
#define otd_vector_VSattach_FAIL		0x00008000
#define otd_metadata_VSattach_FAIL		0x00004000
#define otd_orbit_VSattach_FAIL		0x00002000
#define otd_orbit_summary_VSattach_FAIL	0x00001000
#define otd_orbit_flash_rate_VSattach_FAIL 	0x00000800
#define otd_orbit_event_rate_VSattach_FAIL 	0x00000400
#define otd_ephemeris_VSattach_FAIL 	0x00000200
#define otd_view_VSattach_FAIL		0x00000100
#define otd_grid_25_deg_VSattach_FAIL	0x00000080
#define otd_grid_500_km_VSattach_FAIL	0x00000040
#define otd_threshold_VSattach_FAIL		0x00000020
#define otd_VSsetfields_FAIL		0x00000010
#define otd_inventory_metadata_FAIL		0x00000008
#define otd_archived_metadata_FAIL		0x00000004

#define otd_NoMetadata (FAIL|otd_inventory_metadata_FAIL|otd_archived_metadata_FAIL)

