#include <stdio.h>
#include <math.h>
#include "hdf.h"
#include "liblisotd_err_defs.h"
#include "liblisotd_readhdf.h"
#include <fcntl.h>
#include <stdlib.h>
#define lis_NoMetadata (lis_operation_FAIL|lis_inventory_metadata_FAIL|lis_archived_metadata_FAIL)
#define lis_MissingVdata (lis_VSsetfields_FAIL)
#define lis_NoMetadataMissingVdata (lis_NoMetadata | lis_MissingVdata)

main(int argc, char *argv[]) {
	long fid,i;
	long lis_events, lis_one_seconds, lis_groups, lis_viewtimes, lis_areas;
	struct lis_area *lis_area_var;
	struct lis_event *lis_event_var;
	struct lis_one_second *lis_one_second_var;
	struct lis_group *lis_group_var;
	struct lis_viewtime *lis_viewtime_var;
	char fname[132];
	int temp;
	sprintf(fname,"TRMM_LIS_SC.03.4_1998.028.00970");
/*
	fid = OPEN_lis_orbit_hdf(fname);
    if(((fid&0xffffff00)==lis_NoMetadataMissingVdata))fid = fid^lis_NoMetadataMissingVdata;
	if(((fid&0xffffff00)==lis_NoMetadata))fid = fid^lis_NoMetadata;
    if(((fid&0xffffff00)==lis_MissingVdata))fid = fid^lis_MissingVdata;

	lis_areas = lis_area_COUNT(fid);
	lis_area_var = (struct lis_area *)malloc((size_t)(lis_areas*sizeof(struct lis_area)));
	i = READ_lis_areas(fid,lis_area_var,0,lis_areas);
	for (i=0; i<lis_areas; i++) {
		lis_area_var[i] = lis_area_var[i];
	}

;	lis_events = lis_event_COUNT(fid);
;	lis_event_var = (struct lis_event *)malloc((size_t)(lis_events*sizeof(struct lis_event)));
;	i = READ_lis_events(fid,lis_event_var,0,lis_events);
;	for (i=1000; i<=50000; i+=1000) {
;		lis_event_var[i] = lis_event_var[i];
;	}


	lis_one_seconds = lis_one_second_COUNT(fid);
	lis_one_second_var = (struct lis_one_second *)malloc((size_t)(lis_one_seconds*sizeof(struct lis_one_second)));
	i = READ_lis_one_seconds(fid,lis_one_second_var,0,lis_one_seconds);
	for (i=500; i<=5000; i+=500) {
		lis_one_second_var[i] = lis_one_second_var[i];
	}


;	lis_groups = lis_group_COUNT(fid);
;	lis_group_var = (struct lis_group *)malloc((size_t)(lis_groups*sizeof(struct lis_group)));
;	i = READ_lis_groups(fid,lis_group_var,0,lis_groups);

	
	lis_viewtimes = lis_viewtime_COUNT(fid);
	lis_viewtime_var = (struct lis_viewtime *)malloc((size_t)(lis_viewtimes*sizeof(struct lis_viewtime)));
	i = READ_lis_viewtimes(fid,lis_viewtime_var,0,lis_viewtimes);	
*/
		lis_areas = 64;
		temp = sizeof(struct lis_area);
		lis_area_var = (struct lis_area *)malloc((size_t)(lis_areas*sizeof(struct lis_area)));
        fid = OPEN_lis_orbit_hdf(fname);
                        if((fid<0)&&((fid&0xffffff00)!=lis_NoMetadata)){
                                printf("OPEN_lis_orbit_hdf failed area %s : %08x\n",fname,fid);
                                if(CLOSE_lis_orbit_hdf(fid)!=lis_operation_SUCCESSFUL )printf("close %s file failed\n",fname);
                                return(0); 
                                fid = fid&0xff;
                        }
                        if(((fid&0xffffff00)==lis_NoMetadata))fid = fid^lis_NoMetadata;
        lis_areas = lis_area_COUNT(fid);
        if(lis_areas!=0){
			i = READ_lis_areas(fid,lis_area_var,0,lis_areas); 
        }
        if(CLOSE_lis_orbit_hdf(fid)!=lis_operation_SUCCESSFUL )printf("close %s file failed\n",fname);

	return(0);
}
